// This file is a part of the xMule Project.
//
// Copyright (c) 2004 Theodore R. Smith (donate@xmule.org / http://www.xmule.org/)
// RSA-1024 Fingerprint: 4145 9DFD 5338 4FCC 1636  86E5 2E5A 42D8 BA13 460B
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef PPGCON_H
#define PPGCON_H

class CPreferences;
#include "resource.h"

#include <wx/panel.h>
// CPPgConnection dialog

class CPPgConnection : public wxPanel //CPropertyPage
{
  //DECLARE_DYNAMIC(CPPgConnection)
  DECLARE_DYNAMIC_CLASS(CPPgConnection)
    CPPgConnection() {};

public:
	CPPgConnection(wxWindow* parent);
	virtual ~CPPgConnection();

	void SetPrefs(CPreferences* in_prefs) {	app_prefs = in_prefs; }

// Dialog Data
	enum { IDD = IDD_PPG_CONNECTION };
protected:
	CPreferences *app_prefs;
protected:
	//virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	//DECLARE_MESSAGE_MAP()
	DECLARE_EVENT_TABLE()
public:
	//virtual BOOL OnInitDialog();
public:
	void LoadSettings(void);
	void Localize(void);
public:
	void OnApply();
#if 0
	virtual BOOL OnApply();
	afx_msg void OnEnChangeDownloadCap()			{ SetModified(); }
	afx_msg void OnEnChangeUploadCap()				{ SetModified(); }
	afx_msg void OnEnChangeMaxdown()				{ SetModified(); }
	afx_msg void OnEnChangeMaxup()					{ SetModified(); }
	afx_msg void OnEnChangePort()					{ SetModified(); }
	afx_msg void OnEnChangeMaxcon()					{ SetModified(); }
	afx_msg void OnEnChangeMaxsourceperfile()		{ SetModified(); }
	afx_msg void OnEnChangeMaxsourceperfilesoft()	{ SetModified(); }
	afx_msg void OnEnChangeMaxsourceperfileudp()	{ SetModified(); }
	afx_msg void OnBnClickedAutoconnect()			{ SetModified(); }
	afx_msg void OnBnClickedReconn()				{ SetModified(); }
#endif
	void OnBnClickedWizard(wxEvent& evt);
	void OnUDPDISABLEChecked(wxEvent& evt);
};

#endif
